<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
<#assign isCurWFDE = false>
<#if app.getAppMode()?? && app.getAppMode() == "WFAPP" && app.getAllPSAppWFs()??>
    <#list app.getAllPSAppWFs() as appwf>
        <#if appwf.getPSWorkflow().getWFProxyMode() == 3 && appwf.getPSWorkflow().getPSWFDEs()??>
            <#list appwf.getPSWorkflow().getPSWFDEs() as wfde>
                <#if wfde.getWFProxyMode() == 2 && wfde.getCodeName() == de.getCodeName()>
                    <#assign isCurWFDE = true>
                    <#break>
                </#if>
            </#list>
            <#if isCurWFDE>
                <#break>
            </#if>
        </#if>
    </#list>
</#if>
package ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.controller;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import com.alibaba.fastjson.JSONObject;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.PageRequest;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.service.${item.getCodeName()}Service;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.domain.${item.getCodeName()};
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.filter.*;

@RestController
@RequestMapping(value = "")
public class ${item.getCodeName()}Controller {
<#assign keyCNLC = "_id">
<#assign itemCodeName = item.getCodeName()>
<#assign itemCodeNameLC = itemCodeName?lower_case>
	@Autowired
    ${item.getCodeName()}Service ${item.getCodeName()?lower_case}service;

<#--  主实体  start -->
<#if item.isMajor()>
<#assign parentPath = ""  >
<#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign parentSearchParams = "" >
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams2 = "">
<#assign id_etParams3 = "">

<#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams3 = etParams3 +  itemCodeNameLC + "">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
<#assign fullPath = parentPath + selfPath>

<#if item.getAllPSAppDEMethods()??>
    <#list item.getAllPSAppDEMethods() as appMethod>
        <#if appMethod.getPSDEServiceAPIMethod()??>
            <#assign reqMtd = appMethod.getPSDEServiceAPIMethod().getRequestMethod()>
            <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}")
    public ResponseEntity<${item.getCodeName()}> ${appMethod.getCodeName()?uncap_first}(${etParams}) {
        ${item.getCodeName()} ${item.getCodeName()?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }

                <#elseif deaction.codeName == 'Update'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${itemCodeName?lower_case}service.${deactionCodeName?uncap_first}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }

                <#elseif deaction.codeName == 'Get'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${idParams}) {
        ${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case});
    }

                <#elseif deaction.codeName == 'GetDraft'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}() {
        //${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(new ${itemCodeName}());
    }

                <#elseif deaction.codeName == 'Remove'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${idParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

               <#elseif deaction.codeName == 'CheckKey'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

                <#else>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }

                </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
                <#assign deds = appMethod.getPSDEDataSet()>
    @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
	public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}(<#if parentParams!="">${parentParams},</#if>${itemCodeName}SearchContext searchContext,Pageable pageable) {
        ${parentSearchParams}
        searchContext.setPageable(pageable);
        Page<${itemCodeName}> page = ${item.getCodeName()?lower_case}service.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams != "">${parentParams3} , </#if>searchContext);
        return ResponseEntity.status(HttpStatus.OK)
                .header("x-page", String.valueOf(pageable.getPageNumber()))
        		.header("x-per-page", String.valueOf(pageable.getPageSize()))
        		.header("x-total", String.valueOf(page.getTotalElements()))
        		.body(page.getContent());
    }

            </#if>
        <#else>
            <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${etParams}) {
        return null;
    }

                <#elseif deaction.codeName == 'Update'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        return null;
    }

                <#elseif deaction.codeName == 'Get'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${idParams}) {
        return null;
    }

                <#elseif deaction.codeName == 'GetDraft'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}() {
        return null;
    }

                <#elseif deaction.codeName == 'Remove'>
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${idParams}) {
        return null;
    }

               <#elseif deaction.codeName == 'CheckKey'>
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParams}) {
        return null;
    }

                <#else>

    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        return null;
    }

                </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
                <#assign deds = appMethod.getPSDEDataSet()>
	public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}() {
        return null;
    }

            </#if>
        </#if>
    </#list>
</#if>
</#if>
<#--  主实体  end  -->

<#--  关系接口  start  -->
<#if item.getPSAppDERSPathCount() gt 0>
  <#list 0..1000 as x>
    <#if x gte item.getPSAppDERSPathCount()>
      <#break>
    <#else>
      <#list item.getPSAppDERSPath(x) as rs>
        <#assign parentPath = ""  >
        <#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
        <#assign parentParams = "">
        <#assign byParams = "By">
        <#assign parentSearchParams = "" >
        <#assign parentParams2 = "">
        <#assign parentParams3 = "">
        <#assign idParams = "">
        <#assign idParams2 = "">
        <#assign idParams3 = "">
        <#assign etParams = "">
        <#assign etParams2 = "">
        <#assign etParams3 = "">
        <#assign id_etParams = "">
        <#assign id_etParams2 = "">
        <#assign id_etParams3 = "">

        <#assign rsMainAppDe = rs.getMajorPSAppDataEntity()>
        <#assign rsMainDe = rsMainAppDe.getPSDataEntity()>
        <#assign rsMainAppDeCN = rsMainAppDe.codeName >
        <#assign rsMainAppDeCNLC = rsMainAppDeCN?lower_case >
        <#assign rsMainDePKCN = rsMainDe.getKeyPSDEField().codeName >
        <#assign rsMainDePKCNLC = rsMainDePKCN?lower_case >
        <#assign rsMainDePKDataType = rsMainDe.getKeyPSDEField().stdDataType >
        <#assign parentPath += "/" + srfpluralize(rsMainAppDeCNLC)?lower_case + "/{" + rsMainAppDeCNLC + keyCNLC + "}" >
        <#if x != 0>
          <#assign parentParams += ", ">
        </#if>
        <#assign parentParams += "@PathVariable(\"" + rsMainAppDeCNLC + keyCNLC + "\") " + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
        <#assign byParams += rsMainAppDeCN >
        <#if rs.getPSDER1N()??>
          <#assign parentSearchParams += "searchContext.setN_" + rs.getPSDER1N().getPSPickupDEField().getCodeName()?lower_case + "_eq("+ rsMainAppDeCNLC + keyCNLC +");" >
        </#if>
        <#assign parentParams2 += "" + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
        <#assign parentParams3 += "" + rsMainAppDeCNLC + keyCNLC >

        <#if parentParams != "" >
          <#assign idParams = parentParams + ", ">
          <#assign idParams2 = parentParams2 + ", ">
          <#assign idParams3 = parentParams3 + ", ">
          <#assign etParams = parentParams + ", ">
          <#assign etParams2 = parentParams2 + ", ">
          <#assign etParams3 = parentParams3 + ", ">
          <#assign id_etParams = parentParams + ", ">
          <#assign id_etParams2 = parentParams2 + ", ">
          <#assign id_etParams3 = parentParams3 + ", ">
        </#if>
        <#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
        <#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
        <#assign etParams3 = etParams3 +  itemCodeNameLC + "">
        <#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
        <#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
        <#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
        <#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
        <#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
        <#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
        <#assign fullPath = parentPath + selfPath>

        <#if item.getAllPSAppDEMethods()??>
          <#list item.getAllPSAppDEMethods() as appMethod>
            <#if appMethod.getPSDEServiceAPIMethod()??>
            <#assign reqMtd = appMethod.getPSDEServiceAPIMethod().getRequestMethod()>
              <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}")
    public ResponseEntity<${item.getCodeName()}> ${appMethod.getCodeName()?uncap_first}${byParams}(${etParams}) {
        ${item.getCodeName()} ${item.getCodeName()?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }

              <#elseif deaction.codeName == 'Update'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${itemCodeName?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }

              <#elseif deaction.codeName == 'Get'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${idParams}) {
        ${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case});
    }

              <#elseif deaction.codeName == 'GetDraft'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}() {
        //${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(new ${itemCodeName}());
    }

              <#elseif deaction.codeName == 'Remove'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${idParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

              <#elseif deaction.codeName == 'CheckKey'>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

              <#else>
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }

              </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
              <#assign deds = appMethod.getPSDEDataSet()>
    @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
	public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}${byParams}(<#if parentParams!="">${parentParams},</#if>${itemCodeName}SearchContext searchContext,Pageable pageable) {
        ${parentSearchParams}
        searchContext.setPageable(pageable);
        Page<${itemCodeName}> page = ${item.getCodeName()?lower_case}service.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>${byParams}(<#if parentParams != "">${parentParams3} , </#if>searchContext);
        return ResponseEntity.status(HttpStatus.OK)
                .header("x-page", String.valueOf(pageable.getPageNumber()))
        		.header("x-per-page", String.valueOf(pageable.getPageSize()))
        		.header("x-total", String.valueOf(page.getTotalElements()))
        		.body(page.getContent());
    }

            </#if>
          <#else>
            <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${etParams}) {
        return null;
    }

                <#elseif deaction.codeName == 'Update'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        return null;
    }

                <#elseif deaction.codeName == 'Get'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${idParams}) {
        return null;
    }

                <#elseif deaction.codeName == 'GetDraft'>
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}() {
        return null;
    }

                <#elseif deaction.codeName == 'Remove'>
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${idParams}) {
        return null;
    }

               <#elseif deaction.codeName == 'CheckKey'>
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParams}) {
        return null;
    }

                <#else>

    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        return null;
    }

                </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
                <#assign deds = appMethod.getPSDEDataSet()>
	public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}${byParams}() {
        return null;
    }

            </#if>
        </#if>
    </#list>
    </#if>
      </#list>
    </#if>
  </#list>
</#if>
<#--  关系接口  end  -->

<#assign isCurWFDE = false>
<#if app.getAppMode()?? && app.getAppMode() == "WFAPP" && app.getAllPSAppWFs()??>
    <#list app.getAllPSAppWFs() as appwf>
        <#if appwf.getPSWorkflow().getWFProxyMode() == 3 && appwf.getPSWorkflow().getPSWFDEs()??>
            <#list appwf.getPSWorkflow().getPSWFDEs() as wfde>
                <#if wfde.getWFProxyMode() == 2 && wfde.getCodeName() == de.getCodeName()>
                    <#assign isCurWFDE = true>
                    <#break>
                </#if>
            </#list>
            <#if isCurWFDE>
                <#break>
            </#if>
        </#if>
    </#list>
</#if>

<#if isCurWFDE>
    <#assign itemPKParam = itemCodeNameLC + keyCNLC>
    <#assign wfFuncParams = "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemPKParam + ", @RequestBody JSONObject data">
    <#assign wfFuncParams2 = itemPKParam + ", data">

    /** 工作流行为 **/

    /**
     * 开始流程【WFStart】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfstart")
    public ResponseEntity<JSONObject> wfStart(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfStart(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程处理【WFSubmit】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfsubmit")
    public ResponseEntity<JSONObject> wfSubmit(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfSubmit(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程结束【WFClose】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfclose")
    public ResponseEntity<JSONObject> wfClose(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfClose(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程跳转【WFGoto】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfgoto")
    public ResponseEntity<JSONObject> wfGoto(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfGoto(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程重启【WFRestart】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfrestart")
    public ResponseEntity<JSONObject> wfRestart(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfRestart(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程撤回【WFRollback】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfrollback")
    public ResponseEntity<JSONObject> wfRollback(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfRollback(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程退回【WFSendBack】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfsendback")
    public ResponseEntity<JSONObject> wfSendBack(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfSendBack(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程重新分配【WFReassign】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfreassign")
    public ResponseEntity<JSONObject> wfReassign(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfReassign(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

    /**
     * 流程标记已读【WFMarkRead】
     */
    @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfmarkread")
    public ResponseEntity<JSONObject> wfMarkRead(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfMarkRead(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }

</#if>
<#--  客户端 流程 实体 启动  -->
<#assign isClientWFDE = false>
<#if de.hasPSDEWF() && de.getAllPSDEWFs()??>
    <#list de.getAllPSDEWFs() as wfde>
        <#if wfde.getWFProxyMode() == 1 >
            <#assign isClientWFDE = true>
            <#break>
        </#if>
    </#list>
<#if isClientWFDE>
    @RequestMapping(method= RequestMethod.GET , value="${fullPath}/wfstart")
	public ResponseEntity<JSONObject> wfstart() {
    	JSONObject json = new JSONObject();
    	json.put("proxydataid", "");
    	json.put("proxymoduleid", "${itemCodeName}");
    	json.put("url", "http://localhost:8112/#/wfcids/null/editview") ;
        return ResponseEntity.status(HttpStatus.OK).body(json);
    }
</#if>
</#if>
}
