<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.filter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.List;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import ${pub.getPKGCodeName()}.util.SearchContext;

@Data
public class ${item.getCodeName()}SearchContext extends SearchContext implements Serializable {

    <#list de.getPSDEFields() as defield>
  <#if defield.getAllPSDEFSearchModes()??>
   <#list defield.getAllPSDEFSearchModes() as formitem>
    <#assign defDataType=formitem.getPSDEField().getDataType()>
       <#if defDataType == "DATETIME">
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
       <#elseif defDataType == "DATE">
    @JsonFormat(pattern="yyyy-MM-dd", timezone="GMT+8")
       <#elseif defDataType == "TIME">
    @JsonFormat(pattern="HH:mm", timezone="GMT+8")
       </#if>
	public ${srfjavatype(formitem.getPSDEField().stdDataType)} ${formitem.getName()?lower_case};//[${defield.getLogicName()}]
   </#list>
  </#if>
 </#list>

}