<#ibiztemplate>
TARGET=PSSYSAPP
</#ibiztemplate>
<#assign httpPort = "8080">
<#if sysrun?? >
  <#if sysrun.getPSDevSlnMSDepApp()??>
    <#--  微服务部署APP  -->
    <#if sysrun.getPSDevSlnMSDepApp().getHttpPort()??>
        <#assign httpPort = sysrun.getPSDevSlnMSDepApp().getHttpPort()?c>
    </#if>
  </#if>
</#if>
server:
  port: ${httpPort}

spring:
  application:
    name: ${app.getPKGCodeName()?lower_case}
  cloud:
    nacos:
      discovery:
        server-addr: 172.16.102.211:8848

feign:
  sentinel:
    enabled: true

# Logger Config
logging:
  level:
    com.sinosig: debug

ibiz:
  appid: ${app.getId()}
  appname: ${app.getName()}
  applogicname: ${app.getPKGCodeName()}

<#if app.getPSSysServiceAPI()??>
app: 
  service: 
    ${app.getPSSysServiceAPI().getCodeName()?lower_case}: 
      service-id: ${app.getPSSysServiceAPI().getServiceCodeName()?lower_case}
</#if>